#!/bin/bash
# Desc: Template to report seconds until beginning of next hour
# Author: Steven Baltaktei Sandoval; License: GPLv3+

#==BEGIN Define script parameters==
#===BEGIN Declare local script functions===
yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
die() { yell "$*"; exit 111; }
try() { "$@" || die "cannot $*"; }
timeUntilNextHour(){
    # Desc: Report seconds until next hour
    # Output: stdout: integer seconds until next hour
    # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
    # Usage: timeUntilNextHour
    # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
    local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
    TIME_CURRENT="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
    TIME_NEXT_HOUR="$(date -d "$TIME_CURRENT next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
    SECONDS_UNTIL_NEXT_HOUR="$(( $(date +%s -d "$TIME_NEXT_HOUR") - $(date +%s -d "$TIME_CURRENT") ))"; # Calculate seconds until next hour (res. 1 second).
    if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
	returnState="true";
    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
	returnState="WARNING_ZERO";
	yell "WARNING:Reported time until next hour exactly zero.";
    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
	returnState="WARNING_NEGATIVE";
	yell "WARNING:Reported time until next hour is negative.";
    fi

    try echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
    
    #===Determine function return code===
    if [[ "$returnState" = "true" ]]; then
	return 0;
    elif [[ "$returnState" = "WARNING_ZERO" ]]; then
	return 1;
    elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
	return 2;
    fi
} # Report seconds until next hour
#===END Declare local script functions===
#==END Define script parameters==


#==BEGIN sample code==
try echo "Time until next hour (seconds):$(timeUntilNextHour)" # simple report

if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.
#==END sample code==